Tutorial is loading...

Tutorial is loading...

Tutorial is loading...

Tutorial is loading...

Tutorial is loading...

Tutorial is loading...

# | User | Rating |
---|---|---|

1 | jiangly | 3677 |

2 | Benq | 3601 |

3 | ecnerwala | 3542 |

4 | maroonrk | 3540 |

5 | cnnfls_csy | 3539 |

6 | orzdevinwang | 3493 |

7 | inaFSTream | 3478 |

8 | Um_nik | 3430 |

9 | Rebelz | 3409 |

10 | Geothermal | 3408 |

# | User | Contrib. |
---|---|---|

1 | maomao90 | 174 |

2 | adamant | 165 |

3 | awoo | 162 |

4 | TheScrasse | 161 |

5 | nor | 159 |

6 | maroonrk | 158 |

7 | SecondThread | 156 |

8 | Um_nik | 153 |

9 | Geothermal | 145 |

9 | BledDest | 145 |

Tutorial is loading...

Tutorial is loading...

Tutorial is loading...

Tutorial is loading...

Tutorial is loading...

Tutorial is loading...

Tutorial of Codeforces Round 765 (Div. 2)

↑

↓

Codeforces (c) Copyright 2010-2024 Mike Mirzayanov

The only programming contests Web 2.0 platform

Server time: Feb/27/2024 12:36:47 (j1).

Desktop version, switch to mobile version.

Supported by

User lists

Name |
---|

Thanks for the editorial ^^

E1 WA on TC3 ,implemented using Mo's algo, help !!

`

InputExpected OutputYour OutputComment$$$S[3 \dots 4] = ()$$$ Clearly, there's just 1 way to permute it.

My O(max(n,q) * sqrt(n) * log(max(q,sqrt(n))) solution to E1

This solution works even when the segment asked in query is not a RBS. Note that log factor can be removed on using pointers and using prefix sum(for heavy chains).

Can someone explain the Binary Spiders solutions.

+. more detail if it's possible. cause I'm dealing with tries first time. and i watching about tries there. i got the gist of the idea. but here the process of finding the maximum subset for

iin the trie is little bit complicated. thanks in advancelet's give it a trie.

this is my solution which is a little different than the one in the editorial.

First, let's focus on the MSB of K and try to group the number based on bits starting from the MSB position to the end. for example, if we have K=00010101

so we're interested in the prefix part till the first 1 bit, split k like that.

0001 | 0101

and we split numbers at the same position to height bits and lowest bits

0110 | 1000

0110 | 1001

1010 | 1100

1011 | 1010

0001 | 1001

0111 | 1000

group numbers by the first part.

observation-1 look at the left part (highest bits) if this part is equal then XOR will be zero and it's bad as it will make our XOR lower than K, so the max we can get from this group is only one element.

observation-2 if the left part only differs at the lowest bit then we can get one element from each group, we just need to know that the XOR between these two elements is >=K and we can do this using trie (later I will explain how).

observation-3 if the bits are different then it's guaranteed that it will produce a number greater than K.

so getting to the Trie part, the trie is only needed in observation two, if we found two numbers have the same prefix and differ only in the first bit.

so to check that we're checking two groups A, B and trying to find if we have any two pairs that have XOR >=k. put all the numbers in group A in a trie, our binary trie will have left as zero bit, right as 1 bit. now iterate over numbers in group B, for each number try to find the MAX XOR you can get, basically you iterate over the bits in this number from left to write and try to go to the opposite if possible.

if the current bit is 1 then try to go to 0 in the trie (this will maximize the XOR value).

hope this helped out.

my submission for ref: https://mirror.codeforces.com/contest/1625/submission/142621030

Great, great effort. Really appreciate it. Thankyou so much.

Do anyone have the implementation of problem D, using the approach explained in the editorial?

I followed the editorial's approach 142894864

Please upload the codes also.

For C, I think "min(dp[n][j]) over all 0 <= j <= k" is not the final answer, because that is forcing the n-th sign to be taken (not removed). To get the final answer, we have to enumerate the last taken sign, add the remaining road section's time to each one, and finally take the minimum value among all of them.

We are indexing from $$$0$$$ so element at at index $$$n$$$ is destination city (or simply it's $$$l$$$).

Oh, thank you. That makes sense.

I think problem D memory limit should've been higher if bit-trie solutions were intended to be accepted. Fitting $$$O(n \log A)$$$ memory into 256 MiB is quite a challenge, especially for Java and Python

I was trying O(n^2) solution for Problem C by having additional DP state for propagating last selected speed limit. I am not looking for solution, but if someone can take a look and tell if this would work or not, that would help. Thanks.

142748551

Hey, I am also doing this only. But unable to figure out the mistake. Did you get to know why this will not work. Or anybody else can help us out! Please!! Thank you so much!

My Code -> 142787581 (Similar to @i_will_be_expert's)

PLEASE PLEASE, help us out!

This might help.

On D

Is it actually well known? Does anyone have a proof for why that is the case? Afaik the most common way to solve this problem is by making a bit trie.

In bitwise xor, same bits give us 0, while different bits give us 1. If we try to find minimal xor pair, neighboring numbers have more of the same bits starting from the MSB, which makes the xor value smaller.

Not always true.

Consider 6 7 8, (7^8) is greater than (6^8).

But still the overall minimum comes out as (6^7) which are still the neighboring elements. Its so confusing lol.

Let a,b and c be three numbers such that a<b<c. Let the first bit where a and c differ be the kth bit, then kth bit in a must be unset and it must be set in c. Then depending upon whether kth bit is set in b or not we get (b xor c) <(a xor c) or (b xor a) <(a xor c)

Thanks for explanation.

I think in E2,it is more natural for me to think up the $$$O((n+q)\log n)$$$ solution than the $$$O((n+q)\sqrt n)$$$ solution.

Another thing I've noticed, converting RBS to tree is pretty much the inverse operation of DFS/finding the Eulerian path of a tree. So instead of building the tree explicitly, I found it much more efficient to simply compute the statistics for each node/open bracket in place.

142753393 link to my submission

E2 can still be solved if not only leaves are erased, but each pair must form a matching.

If we build the bracket tree, the erase operation can be transformed to erase a node and link all its sons to its father. The queries can be transformed to sum up $$$k*(k+1)/2$$$ for each node in the interval. We can use unionset to deal with father changes and a Fenwichtree to deal with subtree sum except the root. Degree of the root of each interval can be transformed to occurrences of minumum prefix sum in the interval. It can be maintained by segment tree.

Here is the code.

In question B, the answer seem to be

`n - min(v - u)`

.Yes, you are right. I will fix it soon.

Can someone tell me why doesn't greedy algorithm work for problem C in which we remove the sign which causes a maximum decrease in time. If someone can provide a short test case which I can visualize that would be helpful. Here is my code 142511895

I am also trying greedy approach, do you get info why greedy will not work here?

https://mirror.codeforces.com/blog/entry/99031?#comment-878059 He gave a test case why greedy won't work. Check it out.

Some hints for people stuck at debugging problems

BandC.Iizy Problem:

BInputExpected OutputYour OutputCommentA possible sequence is

Obviously, the last 4 matches, hence it's a valid one.

i_will_be_expert nitigya Problem:

CInputExpected OutputYour OutputCommentThe optimal move is to remove the the signs $$$3$$$ and $$$4$$$, resulting in a total cost of

umanggupta1975 Problem:

CInputExpected OutputYour OutputCommentThe optimal move is to remove signs at $$$1$$$ and $$$2$$$, resulting in a total cost of

HaidRam Problem:

CInputExpected OutputYour OutputCommentThe optimal move is to remove the signs $$$3$$$ and $$$4$$$ resulting in a total cost of

Thanks a lot.

love you

Thanks a lot

Can someone explain E2 solution in $$$O((n+q)\sqrt{n})$$$?

Can anyone suggest why my submission is getting MLE? any possible improvements?

Another solution for problem D using divide and conquer:)

Suppose that now we have a set of spiders, $$$S$$$, to calculate the answer, obviously at first it's just the original set.

Let's look through the bits of $$$k$$$ from high to low, for the $$$i-th$$$ bit, there are two cases:

1. the $$$i-th$$$ bit of $$$k$$$ equals to $$$0$$$. In this case we can divide the set $$$S$$$ into two parts: one set $$$s_0$$$ with all elements whose $$$i-th$$$ bits equal 0, the other set $$$s_1$$$ with all elements whose $$$i-th$$$ bits equal 1. It's for the reason that if we choose any element $$$x$$$ in $$$s_0$$$ and any element $$$y$$$ in $$$s_1$$$, $$$x\ xor\ y$$$ will always be larger than $$$k$$$. Now here come two subproblems with $$$s_0$$$ and $$$s_1$$$ and it goes to the $$$(i-1)-th$$$ bit;

2. the $$$i-th$$$ bit of $$$k$$$ equals to $$$1$$$. In this case we can choose no more than two elements in $$$S$$$, and their $$$i-th$$$ bit must be different. To find the elements, we also need to divide $$$S$$$ into two parts following the rule above, and then go to the $$$(i-1)-th$$$ bit and continue to divide the two sets... To ensure that the two sets we have now always satisfying the property that the $$$xor$$$ of two elements from each must not be less than $$$k$$$. You can view my code for more details.

The time complexity is $$$O(n\cdot log\ max\lbrace a_i, k\rbrace)$$$, here is my code.

Can anyone explain the convex hull trick in problem C? Thx.

Interested in the convex hull trick solution too!

For problem C, why would it not work to use a simple greedy where you pick the sign such that its removal decreases the total time as much as possible, and repeat k times?

144901424

Sorry for necroposting, but I didn't find any solution for this in comments or anywhere

In problem D, The editorial solution uses a trie. if you use trie. Then there are at most nlogA vertices. If we implement using pointers then its memory would be nlogA*32 (32 if because of pointer address size in 32 bit compiler) = 3*10^5*30*30 = 2.7*10^8 ~ 2 GB. But memory limit is just 256 MB. How to solve this issue?

[Deleted]